%*****************************************%
% TFM CONTROL DE UN BRAZO ROBOT DE 5 EJES %
% BY John Vera                            %
%*****************************************%
close all
clc;
clear all


% Crea el area de trabajo en 3 dimensiones x,y,z
entorno; 

% Llama a la tabla de DH del manipulador
TablaDH;

% Declaracion de vectores para la posicin y velocidad
traytotalp=[];
traytotalv=[];

% Crea el dibujo en 3d por lineas segun la tabla de DH
t = 2;   % Tiempo para la ejecucion para la resolucin del movimiento

opc = 1; % Opcion para que el movimiento del brazo robot sea paso a paso o
         % es continuo, opc=0 paso a paso o opc=1 continuo.
         
mov = 1; % Activa o deshabilita el movimiento del brazo robot, 0 off y 1 on

numtray = 3; % Numero de trayectorias a controlar.

% Esta opcin cuando es 1 habilita la generacin de graficas con el 
% movimiento total de cada articulacin, cuando es 0 la deshabilita
graficas = 1; 

pi=[300,0,150,-80,180];


qi = cineinv(pi);
J=J_det(qi);
pi=dh(r,5,qi);

manipulador = makearm(r,qi');
pf = [[0,0,900,90,0];[700,0,200,0,0];[0,-550,200,-45,0]];
i=0;
if(mov==1)
    for i=1:1:numtray
        
        qf = cineinv(pf(i,1:5));
        J=J_det(qf);
        if (imag(J)~=0)
            fprintf('Esta en una posicin singular fuera del espacio de trabajo \n'); 
            graficas=0;
            break;
        end
        if (pf(i,4)>225)||(pf(i,4)<-45)           
            graficas=0;
            break;
        end
        tray = controlcine(qi,qf,t);
        trayvel = controlcinevel(qi,qf,t);
        diburobot(r,manipulador,tray,opc);
        qi=qf;
        traytotalp=vertcat(traytotalp,tray);
        traytotalv=vertcat(traytotalv,trayvel);
              
    
    end
    if(graficas==1)
            figure(2);
            subplot(2,1,1);
            plot(traytotalp(:,1),'r');
            grid minor;
            title('Grafica de la articulacin 1');
            legend('Posicin');
            xlabel('Tiempo'); ylabel('\theta');
            subplot(2,1,2);
            plot(traytotalv(:,1),'b');
            grid minor;
            title('Grafica de la articulacin 1');
            legend('velocidad');
            xlabel('Tiempo'); ylabel('\theta\prime');

            figure(3);
            subplot(2,1,1);
            plot(traytotalp(:,2),'r');
            grid minor;
            title('Grafica de la articulacin 2');
            legend('Posicin');
            xlabel('Tiempo'); ylabel('\theta');
            subplot(2,1,2);
            plot(traytotalv(:,2),'b');
            grid minor;
            title('Grafica de la articulacin 2');
            legend('velocidad');
            xlabel('Tiempo'); ylabel('\theta\prime');

            figure(4);
            subplot(2,1,1);
            plot(traytotalp(:,3),'r');
            grid minor;
            title('Grafica de la articulacin 3');
            legend('Posicin');
            xlabel('Tiempo'); ylabel('\theta');
            subplot(2,1,2);
            plot(traytotalv(:,3),'b');
            grid minor;
            title('Grafica de la articulacin 3');
            legend('velocidad');
            xlabel('Tiempo'); ylabel('\theta\prime');
            
            figure(5);
            subplot(2,1,1);
            plot(traytotalp(:,4),'r');
            grid minor;
            title('Grafica de la articulacin 4');
            legend('Posicin');
            xlabel('Tiempo'); ylabel('\theta');
            subplot(2,1,2);
            plot(traytotalv(:,4),'b');
            grid minor;
            title('Grafica de la articulacin 4');
            legend('velocidad');
            xlabel('Tiempo'); ylabel('\theta\prime');

            figure(6);
            subplot(2,1,1);
            plot(traytotalp(:,5),'r');
            grid minor;
            title('Grafica de la articulacin 5');
            legend('Posicin');
            xlabel('Tiempo'); ylabel('\theta');
            subplot(2,1,2);
            plot(traytotalv(:,5),'b');
            grid minor;
            title('Grafica de la articulacin 5');
            legend('velocidad');
            xlabel('Tiempo'); ylabel('\theta\prime');
    end
end