/**********************************************************************************
*	ARCHIVO: GLOBAL_VARS.h
*	VARIABLES GLOBALES
*	AUTOR: P.TRUJILLO (2/4/2013)
*	FRENO EOLICO BORNAY
**********************************************************************************/



// VARIABLES CONFIGURACIN ADC
int16 ChSel[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int16 TrigSel[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int16 ACQPS[16]={10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10};

// 	CONTADORES DE EVENTOS DE LOS TIMERS
Uint16 VTimer0 = 0;
Uint16 VTimer1 = 0;
Uint16 VTimer2 = 0;

//	CONTADORES DE EVENTOS DE LOS PWM
Uint16 ePWM1_Count = 0;  
Uint16 ePWM2_Count = 0; 
Uint16 ePWM3_Count = 0;

//	CONTADOR DE EVENTOS DE RECEPCIN DEL SCI
Uint16 SciRX_Count = 0;

// 	CONTADOR DE EVENTOS XINT1
Uint16 XINT1_Count = 0;

//Datos
// Variables del sistema de control
float REFERENCIA_BUCK = 6.0;	// Referencia a seguir por PID_BUCK
float REFERENCIA_BOOST = 12.0;	// Referencia a seguir por PID_BOOST
int Duty_BUCK_BC;		//Seal de control del PWM del BUCK
int Duty_BOOST_BC;		//Seal de control del PWM del BOOST
int ACC_CONTROL_BUCK=3500;	//Seal de control
int ACC_CONTROL_BOOST=3500;	//Seal de control
float FDB_BUCK;		//Seal de realimentacin del buck
float FDB_BOOST;	//Seal de referencia del Boost
float ref_buck = 0.5;
float ref_boost = 0.5;

int check;		//variables para pruebas
float check_2;	//
float check_3 = 12000.0;

// Modos de funcionamiento
int	MODO = 1;
int BUCK = 1;
int BOOST = 2;
int STOP = 3;	// Se para. No funciona en ninguno de los dos modos
int MODO_RX = 0;

//Valores lmites para los modos de carga y descarga
Uint16 V_MAX_BAT;	//Tensin mxima a la que se considera que la bateria est cargada
Uint16 V_MIN_BAT;	//Tensin mnima a la que se considera que la bateria est descargada
Uint16 V_MIN_BUS;	//Tensin mnima del bus para que este pueda sumunistrar
Uint16 V_MAX_BUS;	//Tensin mxima del bus
Uint16 I_MIN_BOOST;	//Corriente mnima de la carga de la batera. Por debajo de esta se considera cargada
Uint16 I_MIN_BUCK;	//Corriente mnima del bus. Por debajo de esta se considera que la descarga de la bateria no es efectiva

//Variables referentes a la captura de datos
Uint16 Lectura_temp;		//	TEMPERATURA
Uint16 Lectura_IN_BOOST;	//	Captura de datos de la TENSION entrada del BOOST
Uint16 Lectura_IN_BUCK;		// 	Captura de datos de la TENSIN entrada del BUCK
Uint16 Lectura_IDC_BOOST;	// 	Captura de datos de la CORRIENTE BOOST Solo lee bien en modo Buck
Uint16 Lectura_IDC_BUCK;	// 	Captura de datos de la CORRIENTE BUCK Solo lee bien en modo Boost
Uint16 IN_BOOST_filtrada = 0; 	//Valor filtrado de la lectura de TENSION de entrada del BOOST
Uint16 IN_BUCK_filtrada = 0; 	//Valor filtrado de la lectura de TENSION de entrada del BUCK
Uint16 V_IN_BUCK;	//Valor en voltios de la lectura (Lectura_IN_BUCK)
Uint16 V_IN_BOOST;	//Valor en voltios de la lectura (Lectura_IN_BOOST)
Uint16 I_IDC_BUCK;	//Valor en Amperios de la lectura de R1 (Lectura_IDC_BUCK)
Uint16 I_IDC_BOOST;	//Valor en Amperios de la lectura de R2 (Lectura_IDC_BOOST)

//	TRAMAS DE ENVIO Y RECEPCIN DEL SCI
unsigned char trama_RX[4], trama_TX[4];




//	ESTRUCTURAS DE FLAGS

struct FLG_SYS1 {        // bits   description
	unsigned int LIBRE1:1;   // 3      
	unsigned int LIBRE2:1;       	// 4      
	unsigned int LIBRE3:1;      // 10     
	unsigned int LIBRE4:1;      // 11     
	unsigned int LIBRE5:1;      // 12     
	unsigned int LIBRE6:1;      // 8      
	unsigned int LIBRE7:1;      // 9      
	unsigned int LIBRE8:1;      // 10     
	unsigned int LIBRE9:1;      // 11     
	unsigned int LIBRE10:1;      // 12     
	unsigned int LIBRE11:1;      // 13     
	unsigned int LIBRE12:1;      // 14     
	unsigned int LIBRE13:1;      // 15 
	unsigned int LIBRE14:1;      // 15 
	unsigned int LIBRE15:1;      // 15 
	unsigned int LIBRE16:1;      // 15    
} FLG_FSM_REG;


/*
struct FLG_SYS {        // bits   description
	unsigned int LIBRE1:1;   // 3      
	unsigned int LIBRE2:1;       	// 4      
	unsigned int LIBRE3:1;      // 10     
	unsigned int LIBRE4:1;      // 11     
	unsigned int LIBRE5:1;      // 12     
	unsigned int LIBRE6:1;      // 8      
	unsigned int LIBRE7:1;      // 9      
	unsigned int LIBRE8:1;      // 10     
	unsigned int LIBRE9:1;      // 11     
	unsigned int LIBRE10:1;      // 12     
	unsigned int LIBRE11:1;      // 13     
	unsigned int LIBRE12:1;      // 14     
	unsigned int LIBRE13:1;      // 15 
	unsigned int LIBRE14:1;      // 15 
	unsigned int LIBRE15:1;      // 15 
	unsigned int LIBRE16:1;      // 15    
} FLG_FSM_REG;  */
